﻿Imports System.Net.Sockets
Imports System.Text
Imports System.IO
Imports System.Net


Public Class Form1
    Dim clientSocket As New System.Net.Sockets.TcpClient()
    Dim serverStream As NetworkStream
    Dim parameterCounter As Integer = 0

    'Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
    '    connect("")
    'End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles MyBase.Load
        connect("")
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try
            parameterCounter = parameterCounter + 1
            txtReceivedText.Text = ""
            Dim button1clicked As Boolean = True
            'connect("")
            While button1clicked = True
                Dim serverStream As NetworkStream = clientSocket.GetStream()





                If serverStream.CanWrite And serverStream.CanRead Then
                    Try
                        Dim FlangeThickness As String = TextBox1.Text
                        Dim HoleDiameter As String = TextBox2.Text
                        Dim InnerDiameter As String = TextBox3.Text
                        Dim numberOfHoles As String = ComboBox1.SelectedItem
                        Dim OuterDiameter As String = TextBox5.Text
                        'values are rounded to nearest integer

                        Dim numInnerDia As Integer
                        Dim numOuterDia As Integer
                        Dim numHoleDiameter As Integer

                        numInnerDia = CInt(InnerDiameter)
                        numOuterDia = CInt(OuterDiameter)
                        numHoleDiameter = CInt(HoleDiameter)




                        If numInnerDia > numOuterDia Then
                            MessageBox.Show("Outer Diameter has to be larger than Inner Diameter!")
                            button1clicked = False
                            Exit While
                        End If

                        If numberOfHoles > 12 Then
                            MessageBox.Show("Number of holes cannot be larger than 12!")
                            button1clicked = False
                            Exit While
                        ElseIf numberOfHoles < 1 Then
                            MessageBox.Show("Number of holes cannot be smaller than 1!")
                            button1clicked = False
                            Exit While

                        End If

                        If numHoleDiameter > 16 Then
                            MessageBox.Show("Hole Diameter must be smaller than 16 mm!")
                            button1clicked = False
                            Exit While
                        ElseIf numHoleDiameter < 1 Then
                            MessageBox.Show("Hole Diameter must be larger than 1 mm!")
                            button1clicked = False
                            Exit While
                        End If

                        If numberOfHoles = "" Then
                            MessageBox.Show("Select number of holes!")
                            button1clicked = False
                            Exit While
                        Else
                            'MessageBox.Show("number of holes = " & numberOfHoles)
                        End If

                        Dim flangeType As String = ComboBox2.SelectedItem
                        If flangeType = "" Then
                            MessageBox.Show("Select Flange type")
                            button1clicked = False
                            Exit While
                        ElseIf flangeType = "Custom flange" Then
                            'do nothing

                        ElseIf flangeType = "ISO LFB63-250-SF" Then
                            ComboBox1.SelectedItem = "4"
                            ComboBox1.Text = "4"
                            FlangeThickness = "6"
                            HoleDiameter = "8"
                            InnerDiameter = "64"
                            numberOfHoles = "4"
                            OuterDiameter = "95"
                        ElseIf flangeType = "ISO LFB80-300-SF" Then
                            ComboBox1.SelectedItem = "4"
                            ComboBox1.Text = "4"
                            FlangeThickness = "6"
                            HoleDiameter = "8"
                            InnerDiameter = "76"
                            numberOfHoles = "4"
                            OuterDiameter = "110"
                        ElseIf flangeType = "ISO LFB100-400-SF" Then
                            ComboBox1.SelectedItem = "4"
                            ComboBox1.Text = "4"
                            FlangeThickness = "6"
                            HoleDiameter = "8"
                            InnerDiameter = "102"
                            numberOfHoles = "4"
                            OuterDiameter = "130"
                            ComboBox1.Update()

                        Else
                            MessageBox.Show("Select Flange type")
                            button1clicked = False
                            Exit While
                            'MessageBox.Show("flange type: " & flangeType)
                        End If
                        'MessageBox.Show("flange type: " & flangeType)
                        'Send message to the server
                        Dim SendBytes As Byte() = Nothing



                        SendBytes = Encoding.ASCII.GetBytes(FlangeThickness + "," + HoleDiameter + "," + InnerDiameter +"," + numberOfHoles +"," + OuterDiameter + "     ")
                        serverStream.Write(SendBytes, 0, SendBytes.Length)
                        'Read the NetworkStream (serverStream) into a byte buffer
                        txtReceivedText.Clear()
                        Dim bytes(clientSocket.ReceiveBufferSize) As Byte
                        serverStream.Read(bytes, 0, CInt(clientSocket.ReceiveBufferSize))
                        'Output the data received from the host to the console
                        Dim returnData As String = Encoding.ASCII.GetString(bytes)
                        txtReceivedText.Text = txtReceivedText.Text + Environment.NewLine + _
                        "[Client]: " & returnData

                        'check if received text is "customization completed"
                        If InStr(txtReceivedText.Text, "CUSTOMIZATION COMPLETED" & parameterCounter) > 0 Then
                            'MessageBox.Show("inside instr if")
                            txtReceivedText.Clear()
                            Dim jtFilePath As String = "C:\Users\HOLMSEN\Desktop\NX_modeling\flange_expressions.jt"
                            Dim ftpFilePath As String = "ftp://ftp2.summit.no/NTNU/MBM/Flange_expressions.jt"
                            Dim ftpDownloadedFilePath = "C:\New Folder\flange_expressions_downloaded.jt"

                            'This method downloads the file from the FTP server and opens it.
                            My.Computer.Network.DownloadFile(ftpFilePath, ftpDownloadedFilePath, "ntnu", "master", False, 100000, True)

                            Process.Start(ftpDownloadedFilePath)
                            txtReceivedText.Text = txtReceivedText.Text + Environment.NewLine + "[Client]: Opened JT file"
                            txtReceivedText.Clear()
                            'clientSocket.Close()
                            button1clicked = False
                            Exit While

                        Else

                        End If


                    Catch exc As Exception
                        MessageBox.Show(exc.ToString)
                    End Try
                Else
                    If Not serverStream.CanWrite Then
                        txtReceivedText.Text = txtReceivedText.Text + Environment.NewLine + "[Client]: can not write data to this stream"
                        serverStream.Close()
                    Else

                        If Not serverStream.CanRead Then
                            txtReceivedText.Text = txtReceivedText.Text + Environment.NewLine + " [Client]: can not read data from this stream"
                            serverStream.Close()
                        End If
                    End If
                End If
            End While
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try

    End Sub

    Sub connect(ByVal connectValue As String)
        Try
            msg("Client Started")

            'Declares IPaddress and port and tries to connect to server
            Dim localAddr As IPAddress = IPAddress.Parse("129.241.62.200")
            Dim intPort As Integer = "8888"
            clientSocket.Connect(localAddr, intPort)
            'Changes label1 to ...
            'Label1.Text = "Web Basec Customized Design - Server Connected ..."
        Catch ex As Exception
            MessageBox.Show("Connection Failed." & Environment.NewLine & "No response from server", "Error")
            MessageBox.Show(ex.ToString)
            Exit Try
        End Try
    End Sub


    Sub msg(ByVal mesg As String)
        'TextBox1.Text = TextBox1.Text + Environment.NewLine + " >> " + mesg
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        clientSocket.Close()
        Me.Close()

    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub


    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged

    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged

    End Sub

    Private Sub Label1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label1.Click

    End Sub

    Private Sub ComboBox2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox2.SelectedIndexChanged
        Dim flangeType As String = ComboBox2.SelectedItem
        If flangeType = "ISO LFB63-250-SF" Then
            TextBox1.Text = "6"
            TextBox2.Text = "8"
            TextBox3.Text = "64"
            ComboBox1.SelectedItem = "4"
            TextBox5.Text = "95"
            Me.Update()
        ElseIf flangeType = "ISO LFB80-300-SF" Then
            TextBox1.Text = "6"
            TextBox2.Text = "8"
            TextBox3.Text = "76"
            ComboBox1.SelectedItem = "4"
            TextBox5.Text = "110"
            Me.Update()
        ElseIf flangeType = "ISO LFB100-400-SF" Then
            TextBox1.Text = "6"
            TextBox2.Text = "8"
            TextBox3.Text = "102"
            ComboBox1.SelectedItem = "4"
            TextBox5.Text = "130"
            Me.Update()
        End If

    End Sub
End Class
