﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.IO
Imports System.Text.RegularExpressions

'code from http://www.java-samples.com/showtutorial.php?tutorialid=1064
'for the threaded server

Module WBCD_Server
    Sub Main()
        Dim localIpAddress As IPAddress = IPAddress.Parse("129.241.62.200")
        Dim localPort As Integer = "8888"
        Dim serverSocket As New TcpListener(localIpAddress, localPort)
        Dim clientSocket As TcpClient = Nothing
        Dim counter As Integer
        Dim parameterCounter As Integer = 0

        serverSocket.Start()
        msg("Server listening on port: " & localPort)
        counter = 0
        While (True)
            counter += 1
            clientSocket = serverSocket.AcceptTcpClient()
            msg("Client No:" + Convert.ToString(counter) + " started!")
            Dim client As New handleClinet
            client.startClient(clientSocket, Convert.ToString(counter))
        End While

        clientSocket.Close()
        serverSocket.Stop()
        msg("exit")
        'Console.ReadLine()
    End Sub

    Sub msg(ByVal mesg As String)
        mesg.Trim()
        Console.WriteLine(" >> " + mesg)
    End Sub

    Public Class handleClinet
	'this code is what happens when the server handles the client.
        Dim clientSocket As TcpClient
        Dim clNo As String
        Public Sub startClient(ByVal inClientSocket As TcpClient, _
        ByVal clineNo As String)
            Me.clientSocket = inClientSocket
            Me.clNo = clineNo
            Dim ctThread As Threading.Thread = New Threading.Thread(AddressOf doChat)
            ctThread.Start()
        End Sub
        Private Sub doChat()
            Dim requestCount As Integer
            Dim bytesFrom(10024) As Byte
            Dim dataFromClient As String
            Dim sendBytes As [Byte]()
            Dim serverResponse As String
            Dim rCount As String
            requestCount = 0

            While (True)
                Try
                    requestCount = requestCount + 1
                    Dim networkStream As NetworkStream = _
                            clientSocket.GetStream()
                    networkStream.Read(bytesFrom, 0, CInt(clientSocket.ReceiveBufferSize))
                    dataFromClient = System.Text.Encoding.ASCII.GetString(bytesFrom)
                    'remove null characters from string
                    dataFromClient = dataFromClient.Replace(vbNullChar, "")
                    msg("From Client: " & dataFromClient)
                    


                    'declare array
                    Dim arrayExpressions() As String

                    'split array at ","
                    arrayExpressions = dataFromClient.Split(",")
                    Dim strFlangeThickness As String = arrayExpressions(0)
                    Dim strHoleDiameter As String = arrayExpressions(1)
                    Dim strInnerDiameter As String = arrayExpressions(2)
                    Dim strNumberOfHoles As String = arrayExpressions(3)
                    Dim strOuterDiameter As String = arrayExpressions(4)

                    msg("Splitting received data array to strings")

                    Dim strJournalFilePath As String = "C:\Users\HOLMSEN\Desktop\NX_modeling\journal_test_all.vb"
                    Dim strNewJournalFilePath As String = "C:\Users\HOLMSEN\Desktop\NX_modeling\journal_test_all2.vb"

                    'Dim batchFilePath As String = "C:\Program Files (x86)\Siemens\NX 8.5\UGII\morten.bat"
                    Dim batchFilePath As String = "C:\Users\HOLMSEN\Desktop\NX_modeling\morten.bat"
                    Dim jtFilePath As String = "C:\Users\HOLMSEN\Desktop\NX_modeling\flange_expressions.jt"
                    Dim ftpFilePath As String = "ftp://ftp2.summit.no/NTNU/MBM/Flange_expressions.jt"



                    '---------------------SEARCH AND REPLACE

                    'Declare all searchStrings and replaceStrings

                    Dim searchStringFlangeThickness As String = "(expression1, unit1, ""\d+"")"
                    Dim replaceStringFlangeThickness As String = "expression1, unit1, """ & strFlangeThickness & """"

                    Dim searchStringHoleDiameter As String = "(expression2, unit1, ""\d+"")"
                    Dim replaceStringHoleDiameter As String = "expression2, unit1, """ & strHoleDiameter & """"

                    Dim searchStringInnerDiameter As String = "(expression3, unit1, ""\d+"")"
                    Dim replaceStringInnerDiameter As String = "expression3, unit1, """ & strInnerDiameter & """"

                    Dim searchStringNumberOfHoles As String = "(expression4, nullUnit, ""\d+"")"
                    Dim replaceStringNumberOfHoles As String = "expression4, nullUnit, """ & strNumberOfHoles & """"

                    Dim searchStringOuterDiameter As String = "(expression5, unit1, ""\d+"")"
                    Dim replaceStringOuterDiameter As String = "expression5, unit1, """ & strOuterDiameter & """"
                    msg("Declaring searchstrings and replacestrings")

                    Dim objectReader As New StreamReader(strJournalFilePath)
                    Dim textboxJournal As String = objectReader.ReadToEnd

                    textboxJournal = Regex.Replace(textboxJournal, searchStringFlangeThickness, replaceStringFlangeThickness)
                    textboxJournal = Regex.Replace(textboxJournal, searchStringHoleDiameter, replaceStringHoleDiameter)
                    textboxJournal = Regex.Replace(textboxJournal, searchStringInnerDiameter, replaceStringInnerDiameter)
                    textboxJournal = Regex.Replace(textboxJournal, searchStringNumberOfHoles, replaceStringNumberOfHoles)
                    textboxJournal = Regex.Replace(textboxJournal, searchStringOuterDiameter, replaceStringOuterDiameter)

                    Dim strWrite As New StreamWriter(strNewJournalFilePath)
                    strWrite.Write(textboxJournal)
                    strWrite.Close()
                    objectReader.Close()

                    msg("Replaced values and wrote new file at " & strNewJournalFilePath)


                    '-----------RUN BATCH WHICH RUNS JOURNAL
                    Dim objProcess As System.Diagnostics.Process
                    objProcess = New System.Diagnostics.Process()
                    objProcess.StartInfo.FileName = batchFilePath
                    objProcess.StartInfo.WindowStyle = ProcessWindowStyle.Normal

                    objProcess.Start()
                    msg("Batch file started")
                    msg("Customizing design")
                    msg("Exporting JT file")
                    'Wait until the process passes back an exit code 
                    objProcess.WaitForExit()
                    'Free resources associated with this process
                    objProcess.Close()
                    'objProcess.Dispose()
                    msg("Batch file finished")

                    '------------------UPLOAD JT FILE TO FTP SERVER
                    ''''''''''''''''''''''
                    'this code uploads the JT file to the FTP server so it can be downloaded by the client

                    'FTP Upload method based on this tutorial by How To Start Programming
                    'http://howtostartprogramming.com/vb-net/vb-net-tutorial-26-ftp-upload/

                    msg("Starting upload to FTP server")
                    Dim UploadRequest As System.Net.FtpWebRequest = DirectCast(System.Net.WebRequest.Create(ftpFilePath), System.Net.FtpWebRequest)
                    'Line below sets credentials for the FTP server. username=ntnu, password=master
					UploadRequest.Credentials = New System.Net.NetworkCredential("ntnu", "master")
                    UploadRequest.Method = System.Net.WebRequestMethods.Ftp.UploadFile

                    Dim file() As Byte = System.IO.File.ReadAllBytes(jtFilePath)

                    Dim stream As System.IO.Stream = UploadRequest.GetRequestStream()
                    stream.Write(file, 0, file.Length)

                    stream.Close()
                    stream.Dispose()

                    msg("JT file uploaded")

                    '---------send CUSTOMIZATION COMPLETED to client
                    'msg("From client" + clNo + dataFromClient)
                    rCount = Convert.ToString(requestCount)
                    msg("rCount" & rCount)
                    serverResponse = "CUSTOMIZATION COMPLETED" & rCount
                    sendBytes = Encoding.ASCII.GetBytes(serverResponse)

                    networkStream.Write(sendBytes, 0, sendBytes.Length)
                    networkStream.Flush()
                    msg(serverResponse & "(server response)")

                    
                    msg("End of session--------------------------------")

                Catch ex As Exception
                    'MsgBox(ex.ToString)
                End Try

            End While

        End Sub
    End Class
End Module
