' NX 8.5.0.23
' Journal created by HOLMSEN on Mon Mar 11 18:01:43 2013 W. Europe Standard Time
'
Option Strict Off
Imports System
Imports NXOpen

Module NXJournal
Sub Main (ByVal args() As String) 

Dim theSession As Session = Session.GetSession()
' ----------------------------------------------
'   Menu: File->Open...
' ----------------------------------------------
Dim basePart1 As BasePart
Dim partLoadStatus1 As PartLoadStatus
basePart1 = theSession.Parts.OpenBaseDisplay("C:\Users\HOLMSEN\Desktop\NX_modeling\Flange_expressions.prt", partLoadStatus1)

Dim workPart As Part = theSession.Parts.Work

Dim displayPart As Part = theSession.Parts.Display

partLoadStatus1.Dispose()
Dim markId1 As Session.UndoMarkId
markId1 = theSession.SetUndoMark(Session.MarkVisibility.Visible, "Enter Gateway")

Dim markId2 As Session.UndoMarkId
markId2 = theSession.SetUndoMark(Session.MarkVisibility.Visible, "Enter Modeling")

' ----------------------------------------------
'   Menu: Tools->Expression...
' ----------------------------------------------
Dim markId3 As Session.UndoMarkId
markId3 = theSession.SetUndoMark(Session.MarkVisibility.Visible, "Expression")

Dim expression1 As Expression = CType(workPart.Expressions.FindObject("flange_thickness"), Expression)

Dim unit1 As Unit = CType(workPart.UnitCollection.FindObject("MilliMeter"), Unit)

workPart.Expressions.EditWithUnits(expression1, unit1, "6")

Dim expression2 As Expression = CType(workPart.Expressions.FindObject("hole_diameter"), Expression)

workPart.Expressions.EditWithUnits(expression2, unit1, "8")

Dim expression3 As Expression = CType(workPart.Expressions.FindObject("inner_diameter"), Expression)

workPart.Expressions.EditWithUnits(expression3, unit1, "40")

Dim expression4 As Expression = CType(workPart.Expressions.FindObject("number_of_holes"), Expression)

Dim nullUnit As Unit = Nothing

workPart.Expressions.EditWithUnits(expression4, nullUnit, "6")

Dim expression5 As Expression = CType(workPart.Expressions.FindObject("outer_diameter"), Expression)

workPart.Expressions.EditWithUnits(expression5, unit1, "80                                                ")

Dim nErrs1 As Integer
nErrs1 = theSession.UpdateManager.DoUpdate(markId3)

' ----------------------------------------------
'   Menu: File->Export->JT...
' ----------------------------------------------
Dim markId4 As Session.UndoMarkId
markId4 = theSession.SetUndoMark(Session.MarkVisibility.Visible, "Start")

Dim jtCreator1 As JtCreator
jtCreator1 = theSession.PvtransManager.CreateJtCreator()

jtCreator1.IncludePmi = JtCreator.PmiOption.PartAndAsm

jtCreator1.ConfigFile = "C:\Program Files (x86)\Siemens\NX 8.5\pvtrans\tessUG.config"

jtCreator1.JtfileStructure = JtCreator.FileStructure.Monolithic

jtCreator1.AutolowLod = True

jtCreator1.PreciseGeom = True

theSession.SetUndoMarkName(markId4, "Export JT Dialog")

Dim listCreator1 As ListCreator
listCreator1 = jtCreator1.NewLevel()

listCreator1.Chordal = 0.001

listCreator1.Angular = 20.0

listCreator1.TessOption = ListCreator.TessellationOption.Defined

jtCreator1.LodList.Append(listCreator1)

Dim listCreator2 As ListCreator
listCreator2 = jtCreator1.NewLevel()

listCreator2.Chordal = 0.001

listCreator2.Angular = 20.0

listCreator2.TessOption = ListCreator.TessellationOption.Defined

jtCreator1.LodList.Append(listCreator2)

Dim listCreator3 As ListCreator
listCreator3 = jtCreator1.NewLevel()

listCreator3.Chordal = 0.001

listCreator3.Angular = 20.0

listCreator3.TessOption = ListCreator.TessellationOption.Defined

jtCreator1.LodList.Append(listCreator3)

listCreator2.Chordal = 0.0035

listCreator2.Angular = 0.0

listCreator2.Simplify = 0.4

listCreator2.AdvCompression = 0.5

listCreator3.Chordal = 0.01

listCreator3.Angular = 0.0

listCreator3.Simplify = 0.1

listCreator3.AdvCompression = 1.0

Dim markId5 As Session.UndoMarkId
markId5 = theSession.SetUndoMark(Session.MarkVisibility.Invisible, "Export JT")

theSession.DeleteUndoMark(markId5, Nothing)

Dim markId6 As Session.UndoMarkId
markId6 = theSession.SetUndoMark(Session.MarkVisibility.Invisible, "Export JT")

jtCreator1.OutputJtFile = "C:\Users\HOLMSEN\Desktop\NX_modeling\Flange_expressions.jt"
'jtCreator1.OutputJtFile = "C:\Users\HOLMSEN\Dropbox\MASTER\Flange_expressions.jt"

Dim nXObject1 As NXObject
nXObject1 = jtCreator1.Commit()

theSession.DeleteUndoMark(markId6, Nothing)

theSession.SetUndoMarkName(markId4, "Export JT")

jtCreator1.Destroy()

' ----------------------------------------------
'   Menu: Tools->Journal->Stop Recording
' ----------------------------------------------

End Sub
End Module